routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index');

Auth::routes();

Route::group(['prefix' => 'requester'], function () {
    Route::get('tickets/{token}', 'RequesterTicketsController@show')->name('requester.tickets.show');
    Route::post('tickets/{token}/comments', 'RequesterCommentsController@store')->name('requester.comments.store');
    Route::get('tickets/{token}/rate', 'RequesterTicketsController@rate')->name('requester.tickets.rate');
});

Route::post('webhook/bitbucket', 'WebhookController@store');

Route::group(['middleware' => ['auth', 'userLocale']], function () {
    Route::get('profile', 'ProfileController@show')->name('profile.show');
    Route::put('profile', 'ProfileController@update')->name('profile.update');
    Route::post('password', 'ProfileController@password')->name('profile.password');

    Route::get('tickets/merge', 'TicketsMergeController@index')->name('tickets.merge.index');
    //Route::post('tickets/merge', 'TicketsMergeController@store')->name('tickets.merge.store');
    Route::get('tickets/search/{text}', 'TicketsSearchController@index')->name('tickets.search');
    Route::resource('tickets', 'TicketsController', ['except' => ['edit', 'destroy']]);
    Route::post('tickets/{ticket}/assign', 'TicketsAssignController@store')->name('tickets.assign');
    Route::post('tickets/{ticket}/comments', 'CommentsController@store')->name('comments.store');
    Route::resource('tickets/{ticket}/tags', 'TicketsTagsController', ['only' => ['store', 'destroy'], 'as' => 'tickets']);
    Route::post('tickets/{ticket}/reopen', 'TicketsController@reopen')->name('tickets.reopen');

    Route::post('tickets/{ticket}/escalate', 'TicketsEscalateController@store')->name('tickets.escalate.store');
    Route::delete('tickets/{ticket}/escalate', 'TicketsEscalateController@destroy')->name('tickets.escalate.destroy');

    Route::post('tickets/{ticket}/issue', 'TicketsIssueController@store')->name('tickets.issue.store');
    Route::post('tickets/{ticket}/idea', 'TicketsIdeaController@store')->name('tickets.idea.store');

    Route::resource('leads', 'LeadsController');
    Route::get('leads/search/{text}', 'LeadsSearchController@index')->name('leads.search');
    Route::post('leads/{lead}/assign', 'LeadAssignController@store')->name('leads.assign');
    Route::post('leads/{lead}/status', 'LeadStatusController@store')->name('leads.status.store');
    Route::resource('leads/{lead}/tags', 'LeadTagsController', ['only' => ['store', 'destroy'], 'as' => 'leads']);
    Route::resource('leads/{lead}/tasks', 'LeadTasksController', ['only' => ['index', 'store', 'update', 'destroy'], 'as' => 'leads']);

    Route::resource('tasks', 'TasksController', ['only' => ['index', 'update', 'destroy']]);

    Route::resource('teams', 'TeamsController');
    Route::get('teams/{team}/agents', 'TeamAgentsController@index')->name('teams.agents');
    Route::get('teams/{token}/join', 'TeamMembershipController@index')->name('membership.index');
    Route::post('teams/{token}/join', 'TeamMembershipController@store')->name('membership.store');

    Route::group(['middleware' => 'can:see-admin'], function () {
        Route::resource('ideas', 'IdeasController');
        Route::get('roadmap', 'RoadmapController@index')->name('roadmap.index');
        Route::resource('ideas/{idea}/tags', 'IdeaTagsController', ['only' => ['store', 'destroy'], 'as' => 'ideas']);
        Route::post('ideas/{idea}/issue', 'IdeaIssueController@store')->name('ideas.issue.store');

        Route::resource('users', 'UsersController', ['only' => ['index', 'destroy']]);
        Route::get('users/{user}/impersonate', 'UsersController@impersonate')->name('users.impersonate');
        Route::resource('settings', 'SettingsController', ['only' => ['edit', 'update']]);
    });

    Route::get('reports', 'ReportsController@index')->name('reports.index');
});

app/Lead.php
<?php

namespace App;

use Carbon\Carbon;
use App\Notifications\LeadAssigned;
use Illuminate\Database\Eloquent\SoftDeletes;

class Lead extends BaseModel
{
    use SoftDeletes, Taggable, Assignable, Subscribable;

    const STATUS_NEW           = 1;
    const STATUS_FIRST_CONTACT = 2;
    const STATUS_VISITED       = 3;
    const STATUS_COMPLETED     = 4;
    const STATUS_FAILED        = 5;

    public function team()
    {
        return $this->belongsTo(Team::class);
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function tags()
    {
        return $this->morphToMany(Tag::class, 'taggable');
    }

    public function attachments()
    {
        return $this->morphMany(Attachment::class, 'attachable');
    }

    public function tasks()
    {
        return $this->hasMany(Task::class)->latest();
    }

    public function uncompletedTasks()
    {
        return $this->tasks()->whereCompleted(false);
    }

    public function statusUpdates()
    {
        return $this->hasMany(LeadStatusUpdate::class)->latest();
    }

    public function updateStatus($user, $body, $status)
    {
        if (! $this->user) {
            $this->update(['status' => $status, 'updated_at' => Carbon::now(), 'user_id' => $user->id]);
        } else {
            $this->update(['status' => $status, 'updated_at' => Carbon::now()]);
        }

        return $this->statusUpdates()->create(['user_id' => $user->id, 'new_status' => $status, 'body' => $body]);
    }

    public static function availableStatus()
    {
        return [
            static::STATUS_NEW           => 'new',
            static::STATUS_FIRST_CONTACT => 'first-contact',
            static::STATUS_VISITED       => 'visited',
            static::STATUS_COMPLETED     => 'completed',
            static::STATUS_FAILED        => 'failed',
        ];
    }

    public function statusName()
    {
        return static::getStatusText($this->status);
    }

    public static function getStatusText($status)
    {
        return static::availableStatus()[$status];
    }

    protected function getAssignedNotification()
    {
        return new LeadAssigned($this);
    }

    public function getSubscribableEmail()
    {
        return $this->email;
    }

    public function getSubscribableName()
    {
        return $this->name;
    }
}

app/Http/Controllers/Api/LeadsController.php
<?php

namespace App\Http\Controllers\Api;

use App\Lead;
use App\User;
use Illuminate\Http\Response;
use App\Notifications\LeadCreated;

class LeadsController extends ApiController
{
    public function store()
    {
        $this->validate(request(), [
            'name'  => 'required|min:3',
            'email' => 'required|email',
            'tags'  => 'required',
        ]);

        $lead = Lead::where('email', request('email'))->orWhere('phone', request('phone'))->first();
        if ($lead) {
            $lead->attachTags(request('tags'));

            return $this->respond(['id' => $lead->id], Response::HTTP_CREATED);
        }

        $lead = Lead::create([
            'email' => request('email'),
            'name'  => request('name'),

            'team_id'     => request('team_id'),
            'username'    => request('username'),
            'company'     => request('company'),
            'city'        => request('city'),
            'country'     => request('country'),
            'phone'       => request('phone'),
            'address'     => request('address'),
            'postal_code' => request('postal_code'),
            'body'        => request('body'),
        ])->attachTags(request('tags'));

        $lead->subscribeToMailchimp();

        User::notifyAdmins(new LeadCreated($lead));

        return $this->respond(['id' => $lead->id], Response::HTTP_CREATED);
    }
}

app/Http/Controllers/LeadsController.php
<?php

namespace App\Http\Controllers;

use App\Lead;
use App\Repositories\LeadsIndexQuery;
use App\Repositories\LeadsRepository;

class LeadsController extends Controller
{
    public function index(LeadsRepository $repository)
    {
        $leads = LeadsIndexQuery::get($repository);

        return view('leads.index', ['leads' => $leads->latest()->paginate(25)]);
    }

    public function show(Lead $lead)
    {
        $this->authorize('view', $lead);

        return view('leads.show', ['lead' => $lead]);
    }

    public function update(Lead $lead)
    {
        $lead->update(request()->all());

        return redirect()->route('leads.index');
    }

    public function create()
    {
        return view('leads.create');
    }

    public function store()
    {
        $this->validate(request(), [
            'name'  => 'required|min:3',
            'email' => 'nullable|unique:leads',
            'phone' => 'nullable|unique:leads',
        ]);

        $lead = Lead::create(request()->except(['tags', 'team_id']))->attachTags(request('tags'));
        if (request('team_id')) {
            $lead->assignToTeam(request('team_id'));
        }

        return redirect()->route('leads.show', $lead);
    }
}

resources/views/leads/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="description comment">
        <div class="breadcrumb">
            <a href="{{ route('leads.index') }}"> {{ trans_choice('lead.lead',2) }} </a>
        </div>
    </div>

    {{ Form::open(["url" => route("leads.store")]) }}
    <div class="comment new-comment">
        @include('components.lead.fields', ["lead" => new App\Lead( request()->all() )])
        <table class="no-padding maxw600">
            @include('components.assignTeamField')
            <tr><td> {{ trans_choice('ticket.tag',2) }}</td><td colspan="4"> <input id="tags" name="tags" value="{{request('tags')}}"></td></tr>
            <tr><td> {{__('ticket.comment') }}</td><td colspan="7"><textarea name="body"> {{ request('body') }}</textarea></td></tr>
            <tr><td colspan="3"><button class="uppercase"> @icon(plus) {{ __('ticket.new') }}</button></td></tr>
        </table>
        {{ Form::close() }}
    </div>
@endsection


@section('scripts')
    @include('components.js.taggableInput', ["el" => "tags", "endpoint" => "leads", "object" => null])
@endsection

resources/views/leads/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="description">
        <h3>{{ trans_choice('lead.lead',2) }} ( {{ $leads->count() }} )</h3>
    </div>

    <div class="m4">
        <a class="button " href="{{ route("leads.create") }}">@icon(plus) {{ __('lead.newLead') }}</a>
    </div>
    <div class="float-right mt-5 mr4">
        <input id="searcher" placeholder="{{__('lead.search')}}" class="ml2 shadow-outer-3" style="border-color:#eee">
        <div class="inline ml-4">@icon(search)</div>
    </div>

    <div id="results"></div>
    <div id="all">
        @paginator($leads)
        @include('leads.indexTable')
        @paginator($leads)
    </div>
@endsection

@section('scripts')
    <script>
        $("#searcher").searcher('leads/search/');
    </script>
@endsection

resources/views/leads/indexTable.blade.php
<table class="striped">
    <thead>
    <tr>
        <td class="small"> </td>
        <th> {{ __('lead.company')              }}</th>
        <th> {{ __('lead.name')                 }}</th>
        <th class="hide-mobile"> {{ __('team.email')                }}</th>
        <th class="hide-mobile"> {{ trans_choice('ticket.tag',   2) }}</th>
        <th> {{ trans_choice('team.team',    1) }}</th>
        <th> {{ __('ticket.assigned')           }}</th>
        <th> {{ trans_choice('lead.status',  2) }}</th>
        <th class="hide-mobile"> {{ trans_choice('lead.task',    2) }}</th>
        <th class="hide-mobile"> {{ __('ticket.requested')          }}</th>
        <th class="hide-mobile"> {{ __('ticket.updated')            }}</th>
    </tr>
    </thead>
    <tbody>
    @foreach($leads as $lead)
        <tr>
            <td > @gravatar( $lead->email ) </td>
            <td> <a href="{{route('leads.show',$lead)}}"> {{ $lead->company }}          </a></td>
            <td> <a href="{{route('leads.show',$lead)}}"> {{ $lead->name }}             </a> </td>
            <td class="hide-mobile"> <a href="mailto:{{$lead->email}}" target="_blank"> {{ $lead->email }}  </a> </td>
            <td class="hide-mobile"> {{ $lead->tagsString(", ") }}  </td>
            <td> {{ nameOrDash( $lead->team ) }}</td>
            <td> {{ nameOrDash( $lead->user ) }}</td>
            <td> <a class="label lead-status-{{ $lead->statusName() }}" href="{{ route('leads.show', $lead) }}">
                    {{ __("lead." . $lead->statusName() ) }}
                </a>
            </td>
            <td class="hide-mobile">
                @if($lead->uncompletedTasks->count())
                    <span class="label lead-status-failed"> <a href="{{route('leads.tasks.index',$lead)}}" class="white">{{ $lead->uncompletedTasks->count() }}</a></span>
                @endif
            </td>
            <td class="hide-mobile"> {{ $lead->created_at->diffForHumans() }}</td>
            <td class="hide-mobile"> {{ $lead->updated_at->diffForHumans() }}</td>
        </tr>
    @endforeach
    </tbody>
</table>

resources/views/leads/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="description comment">
        <div class="breadcrumb">
            <a href="{{ route('leads.index') }}">{{ trans_choice('lead.lead', 2) }}</a>
        </div>
        <h3> {{ $lead->company }} · {{ $lead->name }} · {{ $lead->email }} </h3>
        @busy <span class="label lead-status-{{ $lead->statusName() }}"> {{ __("lead." . $lead->statusName() ) }} </span> &nbsp;
        <span class="date">{{  $lead->created_at->diffForHumans() }} · {{  nameOrDash($lead->team) }}</span>
        <a class="float-right button secondary mr4 mt-4 mb-5" href="{{ route('leads.tasks.index', $lead) }}"> @icon(tasks) {{ trans_choice('lead.task', 2) }} <span class="label lead-status-failed">{{ $lead->uncompletedTasks->count() }}</span></a>
    </div>

    <div class="description comment">
        {{ Form::open(["url" => route('leads.update',$lead), 'method' => "PUT"]) }}
            @include('components.lead.fields', ["lead" => $lead])
            <button class="uppercase"> {{ __('ticket.update') }}</button>
        {{ Form::close() }}
    </div>
    @include('components.assignActions', ["endpoint" => "leads", "object" => $lead])

    <div class="comment new-comment">
        {{ Form::open(["url" => route("leads.status.store",$lead), "files" => true, "id" => "comment-form"]) }}
        <textarea name="body"></textarea>
        <br>
        @include('components.uploadAttachment', ["attachable" => $lead, "type" => "leads"])
        {{ Form::hidden("new_status", $lead->status, ["id" => "new_status"]) }}

        <button class="mt1 uppercase ph3"> @icon(comment) {{ __('ticket.commentAs') }} {{ __("lead." . $lead->statusName()) }}</button>
        <span class="dropdown button caret-down"> @icon(caret-down) </span>
        <ul class="dropdown-container">
            @foreach(App\Lead::availableStatus() as $value => $status)
                <li><a class="pointer" onClick="setStatusAndSubmit( {{ $value    }} )"><div style="width:10px; height:10px" class="circle inline lead-status-{{$status}} mr1"></div> {{ __('ticket.commentAs') }} <b>{{ __("lead.$status") }}   </b> </a></li>
            @endforeach
        </ul>
        {{ Form::close() }}
    </div>
    @include('components.leadStatus')
@endsection

@section('scripts')
    @include('components.js.taggableInput', ["el" => "tags", "endpoint" => "leads", "object" => $lead])
    <script>
        function setStatusAndSubmit(new_status){
            $("#new_status").val(new_status);
            $("#comment-form").submit();
        }
    </script>
@endsection